#!/usr/bin/env python


import sys
from optparse import OptionParser
from datetime import datetime,timedelta
import xmlrpclib
import os
import re
import time
import struct
import StringIO
sys.path.append('/usr/lib/groovix-util/python/')
import ConfigParser
import groovix_lib
import subprocess

import socket
# login screen won't work if timeout is longer than 30 seconds ( 60 seconds seems to be the default timeout)
# login screen refreshes pacrez info every 30 seconds, ideally the timeout should be passed as a parameter
#  so that the login screen calling pacrez can use a shorter timeout.  for now 10 secons should be plenty long
socket.setdefaulttimeout(10)


def getThresholds(pacrezserver,myversion,mypass,timezone,label,user):
    pacrezserver,myversion,mypass,timezone,label=getConf(pacrezserver,myversion,mypass,timezone,label);
    rc=0
    threshold_y=24
    threshold_o=14
    threshold_r=4
    rm=''
    try:
        s = xmlrpclib.ServerProxy(pacrezserver,use_datetime=True)
        #print "makeRez "+myversion+" "+mypass+" "+timezone+" "+label+" "+user+" "+starttime+" "+duration
        xrc,xrm,threshold_y,threshold_o,threshold_r=s.getThresholds(myversion,mypass,timezone,label,user)
        rc=xrc
        rm=xrm
    #except ZeroDivisionError:
    except:
      rm="could not connect to pac rez server"
      rc=2 

    return rc,rm,threshold_y,threshold_o,threshold_r

def makeRez(pacrezserver,myversion,mypass,timezone,label,user,starttime,duration):
    #starttime = now or datetime object
    #duration = minutes or min or max or default or bonus (bonus extension interval + 2 minutes) 
    pacrezserver,myversion,mypass,timezone,label=getConf(pacrezserver,myversion,mypass,timezone,label);
    rc=0
    rm=''
    try:
        s = xmlrpclib.ServerProxy(pacrezserver,use_datetime=True)
        #print "makeRez "+myversion+" "+mypass+" "+timezone+" "+label+" "+user+" "+starttime+" "+duration
        xrc,xrm=s.makeRez(myversion,mypass,timezone,label,user,starttime,duration)
        rc=xrc
        rm=xrm
    #except ZeroDivisionError:
    except:
      rm="could not connect to pac rez server"
      rc=2 

    return rc,rm

def logoutUser(user):
     return makeRez(None,None,None,None,None,user,"now","logout")

def cacheInfo(tfilename,message):
  #write out minutes left to file for caching purposes so other programs like screenlock and cmon can reference this
  try:
    outfile=open(tfilename,'w')
    outfile.write(message)
    outfile.close
  except:
    #we can just give up
    pass
    #except ZeroDivisionError:
    #if we're not running as root, or user has never been officially logged in (creating '/var/lib/groovix/pac/userinfo/'+str(user) ) 
    print "cannot write to "+tfilename
    #, then use /tmp
    #filepath=os.path.join('/tmp','.timeinfo-'+str(user))
    #outfile=open(filepath,'w')



def pacreztick(pacrezserver,myversion,mypass,timezone,machine,user):
    rc=0
    usage_s=-1
    rm=""
    #pass most everything on, also gather session usage and do computations to be consistent with pactime
    rc,rm,nowtime,crc,crezuser,c_start_time,c_end_time,frc,frezuser,f_start_time,f_end_time=pacRezCheck(pacrezserver,myversion,mypass,timezone,machine)

    
    if (  updaterc != 0):
       #we communicated successfully, but the return code indicates a problem
       rm="Error in "+reztimeserver+", time remaining is unknown"
       #don't deny them if server can't be reached for any reason
       rc=2
       rm=updaterm
       usage_s=0

    if ( not (crezuser == user)) :
        rc=10
        rm="This machine is reserved for another user"
        usage_s=0

    #get additional details handy for daemon
    if (usage_s == -1):
        usage_s=int(get_session_usage(user))

#    rm+= "Server Time is: " + nowtime
#    rm+= "Reservation ends at: "+c_start_time
#  print "Server Time is: ",
#  print nowtime
#  print "Current Reservation:"
#  print crezuser,
#  if (crc == 0):
#   print " from ",
#   print c_start_time,
#   print " to ",
#   print c_end_time,
#  print "\nNext Reservation:"
#  print frezuser,
#  if (frc == 0):
#   print " from ",
#   print f_start_time,
#   print " to ",
#   print f_end_time,
#  print
#  print rm


    return rc,rm,nowtime,crc,crezuser,c_start_time,c_end_time,frc,frezuser,f_start_time,f_end_time

def getConf(pacrezserver,myversion,mypass,timezone,machine):
  #if not defined already, get from config file
  config=ConfigParser.ConfigParser()
  config.read("/etc/groovix/pacrez.conf")
  #sys.stderr.write(str(config._sections));
  #print config.items('pacrez')
  if (myversion == None):
    myversion=config.get('pacrez','customid')
  if (mypass == None):
    mypass=config.get('pacrez','custompw')
  if (timezone == None):
    timezone=config.get('pacrez','timezone')
  if (pacrezserver == None):
    pacrezserver=config.get('pacrez','pacrezserver')
  if (machine == None):
    #f=open('/etc/hostname', 'r')
    #f=open('/etc/groovix/label', 'r')
    #machine=(f.read()).strip()
    machine=(subprocess.check_output(["groovix-get-parameter","GX_LABEL"])).strip()
  
  return pacrezserver,myversion,mypass,timezone,machine

def checkAndExtend(pacrezserver,myversion,mypass,timezone,label,username):
  rezuser="unknown"
  rc=0

  pacrezserver,myversion,mypass,timezone,label=getConf(pacrezserver,myversion,mypass,timezone,label);


  #define a full message with more info
  fm=""

  try:
    s = xmlrpclib.ServerProxy(pacrezserver,use_datetime=True)
    #print myversion
    #print mypass
    #print timezone
    #print machine
    rc,rm,nowtime,crc,crezuser,c_start_time,c_end_time,frc,frezuser,f_start_time,f_end_time=s.checkAndExtend(myversion,mypass,timezone,label,username)

      
  
  #except xmlrpclib.ProtocolError: (OR socket.error: (110, 'Connection timed out')
  #except ZeroDivisionError:
  except:
    #rc=2 means bad connection, daemon can choose not to deny them if server can't be reached for any reason
    #return rc,rm,crc,crezuser,c_start_time,c_end_time,frc,frezuser,f_start_time,f_end_time
    rc=2
    rm="Could not connect to "+pacrezserver+", reservation status is unknown"
    nowtime="unknown"
    crc=0
    crezuser="unknown"
    c_start_time="unknown"
    c_end_time=None
    frc=0
    frezuser="unknown"
    f_start_time="unknown"
    f_end_time="unknown"
    #return  rc,rm,"none",0,"unknown","none" , "none",0,"unknown","none","none"
    
  #cacheInfo('/var/lib/groovix/pac/userinfo/'+str(username)+'/time.infocache',rm+" \n"+"Reserved for "+str(crezuser)+" until "+str(c_end_time))
  cacheInfo('/var/lib/groovix/session-info/'+str(username)+'.time-infocache',rm+" \n"+"Reserved for "+str(crezuser)+" until "+str(c_end_time))



  return rc,rm,nowtime,crc,crezuser,c_start_time,c_end_time,frc,frezuser,f_start_time,f_end_time

def pacRezCheck(pacrezserver,myversion,mypass,timezone,machine):
  rezuser="unknown"
  rc=0

  pacrezserver,myversion,mypass,timezone,machine=getConf(pacrezserver,myversion,mypass,timezone,machine);


  #define a full message with more info
  fm=""

  try:
    s = xmlrpclib.ServerProxy(pacrezserver,use_datetime=True)
    #print myversion
    #print mypass
    #print timezone
    #print machine
    rc,rm,nowtime,crc,crezuser,c_start_time,c_end_time,frc,frezuser,f_start_time,f_end_time=s.checkPacRez(myversion,mypass,timezone,machine)

      
  
  #except xmlrpclib.ProtocolError: (OR socket.error: (110, 'Connection timed out')
  #except ZeroDivisionError:
  except:
    #rc=1 means bad connection, daemon can choose not to deny them if server can't be reached for any reason
    #return rc,rm,crc,crezuser,c_start_time,c_end_time,frc,frezuser,f_start_time,f_end_time
    rc=2
    rm="Could not connect to "+pacrezserver+", reservation status is unknown"
    nowtime="unknown"
    crc=0
    crezuser="unknown"
    c_start_time="unknown"
    c_end_time="unknown"
    frc=0
    frezuser="unknown"
    f_start_time="unknown"
    f_end_time="unknown"
    #return  rc,rm,"none",0,"unknown","none" , "none",0,"unknown","none","none"
    

  #cacheInfo('/var/lib/groovix/pac/rez_login.infocache',rm+" \n"+"Current:"+str(crezuser)+" until "+str(c_end_time)+",\nFuture: "+str(frezuser)+" at "+str(f_start_time))

  return rc,rm,nowtime,crc,crezuser,c_start_time,c_end_time,frc,frezuser,f_start_time,f_end_time


def get_session_usage(username):
    current_time=datetime.now()
    login_time=get_login_time(username)
    time_diff=current_time-login_time
    #add on a minute since other database-based time usage is set to 1 minute upon login
    return 1+time_diff.days*24*60+time_diff.seconds/60

def get_login_time(username):
    #relies on timestamp written during /etc/gdm/PostLogin/Default, not ideal,
    #but the approach commented out below has problems too
    try:
      #last_login_time=os.path.getmtime("/var/lib/groovix/pac/userinfo/"+username+"/login_time")
      last_login_time=os.path.getmtime("/var/lib/groovix/session-info/"+username+".effective-login-time")
      last_local_time=time.localtime(last_login_time)
      last_login_time=datetime(*last_local_time[:6])
    except:
      print "could not find user login stamp at "+"/var/lib/groovix/session-info/"+username+".effective-login-time"
      try:
        last_login_time=get_login_time_utmp(username)
      except:
        last_login_time=0
    #print last_local_time
    return last_login_time

def get_login_time_utmp(username):
    #use only if other method fails, utmp shows all "login" processes which include xterms run by the user
    #we could take the first entry for the user, utmp seems to order them oldest first
    rec = WTmpRecord()
    #f = open("/var/log/wtmp","rb")
    f = open("/var/run/utmp","rb")
    while True:
        bin = f.read(rec.size())
        if len(bin) != rec.size():
            break
        rec.unpack(bin)
        #if rec.type == 7:
        if True:
          if rec.User == username :
          #if True:
            #print " %1d %-8s %-12s %-24s %-20s %5d %08x" % \ (rec.type, rec.User, rec.Line, time.strftime("%a %Y-%m-%d %H:%M:%S",time.localtime(rec.time)), rec.Hostname, rec.PID, rec.addr)
            #print "exit status is "
            #print rec.exit_status

            last_local_time=time.localtime(rec.time)
           #print last_local_time
            last_login_time=datetime(*last_local_time[:6])
            #print last_login_time
            break
        if bin == "":
          break

    f.close()
    return last_login_time

class WTmpRecord:
    fmt = "hI32s4s32s256siili4l20s";
    _fieldnames = ["type","PID","Line","inittab","User","Hostname",
                    "exit_status", "session", "time", "addr" ]
    def __init__(self):
        self._rec_size = struct.calcsize(self.fmt)
    def size(self):
        return self._rec_size
    def unpack(self, bin_data):
        rec = struct.unpack(self.fmt, bin_data)
        self._rec = []
        for i in range(len(rec)):
            if i in (2,3,4,5):
                # remove character zeros from strings
                self._rec.append( rec[i].split("\0")[0] )
            else:
                self._rec.append(rec[i])
        return self._rec
    def fieldnames(self):
        return self._fieldnames
    def __getattr__(self,name):
        return self._rec[self._fieldnames.index(name)]


def get_status():

       # TODO: make no-show delay configuration, hardcoded for now
       no_show_minutes=5

       rc,pacrezerrormessage,nowtime,crc,crezuser,c_start_time,c_end_time,frc,frezuser,f_start_time,f_end_time=pacRezCheck(None,None,None,None,None)

       #don't show the end time of the reservation, will just lead to confusion if the local clock is off!  
       # end time in minutes would be # c_end_time.strftime("%I:%M %p")
       if (crezuser == "none" and frezuser == "none"):
            fullmessage="This computer is not reserved."
            color="green"
            shortmessage="Not Reserved"
            #switch to non-reserved mode
            code='groovix-pacrez-screensaver-picmode'
       elif (crezuser == "unknown"):
            fullmessage="Could not connect to the pac reservation server,\nreservation status is unknown."
            color="grey"
            shortmessage="reservation status is unknown"
            #switch to non-reserved mode
            code='groovix-pacrez-screensaver-picmode'
       elif (crezuser != "none"  ):
            #fullmessage="This computer has a current reservation\nvalid until "+str(c_end_time.strftime("%I:%M %p"))
            expiration_countdown=min(c_end_time-nowtime,c_start_time+timedelta(minutes=no_show_minutes)-nowtime);
            #print str(expiration_countdown.seconds)
            #must add on days (if we somehow get negative things, timedelta is -1 days + 23 hours 59 minutes) , add  59 seconds to round (ceil) up
            expiration_countdown_minutes,expiration_countdown_seconds=divmod(24*60*60*expiration_countdown.days+expiration_countdown.seconds+59,60)
            if ( expiration_countdown_minutes <= 0 ):
               #cancel the reservation by "logging them out" which will end their reservation
               logoutUser(crezuser)
               fullmessage="This computer is no longer reserved."
               color="green"
               shortmessage="Not Reserved Anymore"
               #switch to non-reserved mode
               code='groovix-pacrez-screensaver-picmode'
            else:
              if ( expiration_countdown_minutes == 1):
                  minutestring=" minute."
              else:
                  minutestring=" minutes."
              fullmessage="This computer has a current reservation\nthat may expire in "+str(expiration_countdown_minutes) + minutestring
              shortmessage="Reserved Until "+str((min(c_end_time,c_start_time+timedelta(minutes=no_show_minutes))).strftime("%I:%M %p"))
              color="red"
              #switch to show reservation mode
              code='groovix-pacrez-screensaver-rezmode'

       elif (frezuser != "none" and f_start_time.date() == nowtime.date() ):
            #we only care about future reservations for TODAY
            #fullmessage="This computer has a future reservation\nstarting at "+str(f_start_time.strftime("%I:%M %p"))
            start_countdown=f_start_time-nowtime;
            #print str(start_countdown.seconds)
            #must add on days (if we somehow get negative things, timedelta is -1 days + 23 hours 59 minutes) , add  59 seconds to round (ceil) up
            start_countdown_minutes,start_countdown_seconds=divmod(24*60*60*start_countdown.days+start_countdown.seconds+59,60)
            if ( start_countdown_minutes == 1):
                  minutestring=" minute at "
            else:
                  minutestring=" minutes at "

            fullmessage="This computer has a future reservation\nstarting in "+str(start_countdown_minutes)+minutestring+str(f_start_time.strftime("%I:%M %p"))
            shortmessage="Reserved At "+str(f_start_time.strftime("%I:%M %p"))
            color="yellow"
            #switch to show reservation mode
            code='groovix-pacrez-screensaver-rezmode'

       else:
            fullmessage="This computer is not reserved"
            shortmessage="Not Reserved"
            color="green"
            #switch to non-reserved mode
            code='groovix-pacrez-screensaver-picmode'

       #write out for screensaver and pactime to use
       #pacrez.cacheInfo('/var/lib/groovix/pac/rez_login.infocache',rm+" \n"+"Current:"+str(crezuser)+" until "+str(c_end_time)+",\nFuture: "+str(frezuser)+" at "+str(f_start_time))
       #pacrez.cacheInfo('/var/lib/groovix/pac/rez_login.infocache',shortmessage)
       #cacheInfo('/var/lib/groovix/pac/userinfo/none/time.infocache',shortmessage)
       cacheInfo('/var/lib/groovix/session-info/none.time-infocache',shortmessage)


       return rc,color,code,shortmessage,fullmessage


def run():
  parser = OptionParser()
  parser.add_option("-t", "--timezone", dest="timezone", help="timezone of local machine")
  parser.add_option("-v", "--version", dest="myversion", help="customer version code")
  parser.add_option("-p", "--password", dest="mypass", help="customer password")
  parser.add_option("-m", "--machine", dest="machine", help="local machine name")
  parser.add_option("-s", "--server", dest="pacrezserver", help="full url to server script, include everything from http:// to .py ")
  parser.add_option("-u", "--user", dest="user", default=None,  help="user name")
  parser.add_option("-l", "--logout", dest="logout", default=False, action="store_true", help="trigger a logout for the specified user")

  (options, args) = parser.parse_args()

#  print options

  user=options.user
  logout=options.logout
  myversion=options.myversion
  mypass=options.mypass
  timezone=options.timezone
  machine=options.machine
  pacrezserver=options.pacrezserver

  if (logout == True):
     rc,rm=logoutUser(user)
  else:
     #the default action is to print info about reservations
     #rc,rezuser,message,fullmessage=pacRezCheck(pacrezserver,myversion,mypass,timezone,machine)
     rc,rm,nowtime,crc,crezuser,c_start_time,c_end_time,frc,frezuser,f_start_time,f_end_time=pacRezCheck(pacrezserver,myversion,mypass,timezone,machine)
     print "Server Time is: ",
     print nowtime
     print "Current Reservation:"
     print crezuser,
     if (crc == 0):
      print " from ",
      print c_start_time,
      print " to ",
      print c_end_time,
     print "\nNext Reservation:"
     print frezuser,
     if (frc == 0):
      print " from ",
      print f_start_time,
      print " to ",
      print f_end_time,
     print
     print rm

  exit(rc)


if __name__ == "__main__":
  run()
