#!/usr/bin/env python

import gtk
import time
import gobject
import sys
import os
from datetime import datetime
import time
import struct
from optparse import OptionParser
import pango
from optparse import OptionParser
import ConfigParser
import StringIO
import subprocess

import pacrez

class StatusIcon:

 def on_left_clicked(self,widget):
     pt_status.window.deiconify()
     pt_status.window.present()

 def makeinvisible(self):
     self.icon.set_visible(False)

 def makevisible(self):
     self.icon.set_visible(True)

 def __init__(self):
  self.icon = gtk.status_icon_new_from_file(pacrez_dir+'/icons/clock_green.png')
  self.icon.connect('activate', self.on_left_clicked)
  self.makeinvisible()


class PacRezStatus:
   
    def force_session_end(self,icon,window,message):
            print message

            #doesn't work since window won't update until we're in the main loop
            #self.label.set_text("\n"+shortmessage+"\n\n"+longmessage)
            #icon.set_tooltip(shortmessage)
            #window.set_title(shortmessage)

            #run zenity in background
            #execlist=['zenity','--error','--title',shortmessage,'--text',longmessage]
            #subprocess.Popen(execlist,stdout=subprocess.PIPE,stderr=subprocess.PIPE)

            ##give them some time to see why the session is ending
            #print "pacrez_daemon has received the exit signal and triggered delayed-pac-exit"
            #os.system("delayed-pac-exit 5 & ")
            #gtk.main_quit()
            #don't need to exit, this will be killed by delayed-pac-exit!
            #print "pacrez_daemon has received the exit signal and triggered delayed-pac-exit"


            #call delayed-pac-exit with 15 seconds
            #execlist=['delayed-pac-exit','15']
            execlist=['groovix-session-forced-exit',message]
            subprocess.Popen(execlist,stdout=subprocess.PIPE,stderr=subprocess.PIPE)
            #os.system("groovix-pac-forced-logout")
            print "exiting pacrez_daemon"
            exit()
      

    def updater(self,icon,window):
      global code
      global oldcode
      global mremain
      global fullmessage 
      global user
      global firstupdate
      global exec_ack
      global threshold_y
      global threshold_o
      global threshold_r

      #hard code for now
      exec_type=0

      lowestlimit=-99
      forceinit=0
      #is this the first update?
      if (firstupdate == 1):
        #legacy: used to be force_new_session now use force_new_session_all_users
        if ( (force_new_session == 1) or (force_new_session_all_users == 1) ):
          forceinit=1
        if ( user in no_rez_required_user_list ):
          forceinit=1
        try:
             #get thresholds
             trc,trm,threshold_y,threshold_o,threshold_r=pacrez.getThresholds(None,None,None,None,None,user) 
        #except ZeroDivisionError:
        except:
             threshold_y=23
             threshold_o=13
             threshold_r=3
        #print "threshold_r is"+str(threshold_r)

        
      #all the None values will be read from the config file or figured out by checkAndExtend
      rc,pacrezerrormessage,nowtime,crc,crezuser,c_start_time,c_end_time,frc,frezuser,f_start_time,f_end_time= pacrez.checkAndExtend(None,None,None,None,None,user)
     

      

      #we've run at least one update
      firstupdate=0;

      #we just sent exec_ack (0 or 1), clear it and set it if necessary for next time
      exec_ack=0



      #forcefully exit if return code from pacreztick is bad
      if ((rc >= 1) and (rc <= 4)):
            #don't force session end for a lost connection
            print "pacrez_daemon: no connection code "+str(rc)+", "+pacrezerrormessage
            lowestlimit=-1
      else:
        if (crc  != 0 ):
            #force session end
            #self.force_session_end(icon,window,"Your reserved time has ended!","Your session will be terminated immediately!\n\n"+pacrezerrormessage)
            self.force_session_end(icon,window,"Your reserved time has ended!\nYour session will be terminated immediately!\n\n"+pacrezerrormessage)
            return 1
      
        if (user != crezuser):
            #force session end
            #self.force_session_end(icon,window,"YOU HAVE NO TIME REMAINING!","YOUR SESSION WILL BE TERMINATED IMMEDIATELY!\n\n"+fullmessage)
            #self.force_session_end(icon,window,"This machine is reserved for another user!","Your session will be terminated immediately!\n\n"+pacrezerrormessage)
            self.force_session_end(icon,window,"This machine is reserved for another user!\nYour session will be terminated immediately!\n\n"+pacrezerrormessage)
            return 1

      
      #unless we couldn't connect to the server let's figure out how much time in minutes is remaining
      if (lowestlimit != -1):
          #to do this we'd have to do it on the server side since the server says we still have a reservation until the exact time!
          ##if < 65 seconds left they get none!
          #lowestlimit,rseconds=divmod((c_end_time-nowtime).seconds-65,60)
          # add on 55 seconds so we don't get "0 minutes remaining" for more than a few seconds. essentially rounding (ceiling) up to the next minute
          lowestlimit,rseconds=divmod((c_end_time-nowtime).seconds+55,60)
          print "lowestlimit is "+str(lowestlimit)
          print "c_end_time is "+str(c_end_time)
          print "nowtime  is "+str(nowtime)

      #print type(lowestlimit)
      #print c_end_time
      #print type(c_end_time)
      #fullmessage="Reservation ends in "+str(lowestlimit)+" minutes at "+ c_end_time.strftime("%I:%M %p")
      #fullmessage=pacrezmessage+"\n\n"+fullmessage
      #fullmessage="test"

      
      if (lowestlimit  > threshold_y):
          code="green"
          fullmessageappend=custom_message_green
      elif (lowestlimit  > threshold_o):
          code="yellow"
          fullmessageappend=custom_message_yellow
      elif (lowestlimit  > threshold_r):
          code="orange"
          fullmessageappend=custom_message_orange
      elif (lowestlimit  > 0 ):
          code="red"
          fullmessageappend=custom_message_red
      else:
          code="error"
          fullmessageappend=custom_message_error


      #don't show the end time of the reservation, will just lead to confusion if the local clock is off!  
      # end time in minutes would be # c_end_time.strftime("%I:%M %p")
      if (lowestlimit == 1):
            fullmessage="Your reservation ends in approximately "+str(lowestlimit)+" minute."
      elif (lowestlimit == -1):
            fullmessage="Could not connect to the pac reservation server, time remaining is unknown."
      else:
            fullmessage="Your reservation ends in approximately "+str(lowestlimit)+" minutes."

      #set text
      self.label.set_text("\n"+fullmessage+"\n\n"+fullmessageappend+"\n")

      #exec if we have a command waiting on server
      if (exec_type == 0):
          #nothing to execute
          pass
      else:
        exec_ack=1
        if (exec_type == 1):
          #zenity info message
          execlist=['zenity','--info','--text',exec_string]
          subprocess.Popen(execlist,stdout=subprocess.PIPE,stderr=subprocess.PIPE)
          #don't need to do anything with return code, just attempt to run it in the background
        elif (exec_type == 2):
          #zenity warning message
          execlist=['zenity','--warning','--text',exec_string]
          subprocess.Popen(execlist,stdout=subprocess.PIPE,stderr=subprocess.PIPE)
          #don't need to do anything with return code, just attempt to run it in the background
        elif (exec_type == 3):
          #zenity error message
          execlist=['zenity','--error','--text',exec_string]
          subprocess.Popen(execlist,stdout=subprocess.PIPE,stderr=subprocess.PIPE)
          #don't need to do anything with return code, just attempt to run it in the background
        elif (exec_type == 8):
          pass
          #exec raw string as user
        elif (exec_type == 9):
          #exec raw string as root (be careful!)
          execlist=[exec_string]
          subprocess.Popen(execlist,stdout=subprocess.PIPE,stderr=subprocess.PIPE)
          #don't need to do anything with return code, just attempt to run it in the background
        else:
          #undefined for now
          print exec_string
          


      


      if ( code != oldcode  ):
        if (code == "green"):
          icon.set_from_file(pacrez_dir+'icons/clock_green.png')
          window.set_icon_from_file(pacrez_dir+'/icons/clock_green.png')

          #blink if iconified, flash if minimized
          if (blink_green):
              icon.set_blinking(True)
              window.set_urgency_hint(True)
          #un-minimize/deiconify, present dialog to user
          if (deiconify_green):
	      window.deiconify()
              window.present()

        elif (code == "yellow"):
          #yellow is a friendly warning, usually 15-30 minutes before ending
          icon.set_from_file(pacrez_dir+'icons/clock_yellow.png')
          window.set_icon_from_file(pacrez_dir+'/icons/clock_yellow.png')

          #blink if iconified, flash if minimized
          if (blink_yellow):
              icon.set_blinking(True)
              window.set_urgency_hint(True)
          #un-minimize/deiconify, present dialog to user
          if (deiconify_yellow):
	      window.deiconify()
              window.present()

        elif (code == "orange"):
          #orange is an urgent warning, usually 5 minutes before ending
          icon.set_from_file(pacrez_dir+'/icons/clock_orange.png')
          window.set_icon_from_file(pacrez_dir+'/icons/clock_orange.png')

          #blink if iconified, flash if minimized
          if (blink_orange):
              icon.set_blinking(True)
              window.set_urgency_hint(True)
          #un-minimize/deiconify, present dialog to user
          if (deiconify_orange):
	      window.deiconify()
              window.present()

        elif (code == "red"):
          #red is the "final" warning, usually 1 minute before ending
          icon.set_from_file(pacrez_dir+'/icons/clock_red.png')
          window.set_icon_from_file(pacrez_dir+'/icons/clock_red.png')

          #blink if iconified, flash if minimized
          if (blink_red):
              icon.set_blinking(True)
              window.set_urgency_hint(True)
          #un-minimize/deiconify, present dialog to user
          if (deiconify_red):
	      window.deiconify()
              window.present()

        else:
          #code=error, for no connection, etc.
          icon.set_from_file(pacrez_dir+'/icons/status_warning.png')
          window.set_icon_from_file(pacrez_dir+'/icons/status_warning.png')

          #blink if iconified, flash if minimized
          if (blink_error):
              icon.set_blinking(True)
              window.set_urgency_hint(True)
          #un-minimize/deiconify, present dialog to user
          if (deiconify_error):
	      window.deiconify()
              window.present()

          


      #mtpre="Warning: "
      #mtpost=" minutes remaining in this session"
      #mremain=mtpre+str(lowestlimit)+mtpost
      #mremain=str(lowestlimit)+mtpost
      mremain=str(lowestlimit)+" minutes remaining"
      mtitle=str(lowestlimit)+" minutes remaining in this session"
      #mtitle=mremain
      #print fullmessage
      #print mremain
      icon.set_tooltip(mremain)
      window.set_title(mtitle)
      #window.set_icon_name(mtitle)


      oldcode=code

      #gobject.timeout_add(59000, self.updater, icon, window )  # call updater every minute - 1 second
      gobject.timeout_add(60000, self.updater, icon, window )  # call updater every minute


    def iconify(self, widget, data=None):
	self.window.iconify()


    def window_state_event(self, widget, event, icon):
        newstate=event.new_window_state
        if (newstate == gtk.gdk.WINDOW_STATE_ICONIFIED):
          self.minimize(icon)

    def minimize(self,icon):
        #print "minimize signal occurred"
        self.window.set_urgency_hint(False)
        icon.set_visible(False)

    def delete_event(self, widget, event, icon, data=None):
        # If you return FALSE in the "delete_event" signal handler,
        # GTK will emit the "destroy" signal. Returning TRUE means
        # you don't want the window to be destroyed.
        #print "delete event occurred"

        icon.set_blinking(False)
        icon.set_visible(True)
        self.window.hide()
        self.window.set_urgency_hint(False)

        return True

    def destroy(self, widget, icon, data=None):
        #shouldn't get here, we expect to catch it in delete_event
        print "Unexpected: destroy signal occurred"

        icon.set_blinking(False)
        icon.set_visible(True)
        self.window.hide()
        self.window.set_urgency_hint(False)

        #gtk.main_quit()

    def __init__(self):
        global fullmessage
        
	status_icon=StatusIcon()

        # create a new window
        self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)

        #define with nothing for now, updater will populate
        self.label = gtk.Label("\n")	
        #style = self.window.get_style().copy()
        #font = self.font_dialog.get_font()
        #style.font='Courier 12' 
        #style.font=font
        #self.window.set_style(style)
        self.label.modify_font(pango.FontDescription("Courier 12"))



    
        self.updater(status_icon.icon,self.window)

        self.window.connect("delete_event", self.delete_event, status_icon.icon)
    
        self.window.connect("destroy", self.destroy, status_icon.icon)

	#to detect minimize, we only hide status icon on minimize to prevent mouse release 
        # from quickly minimizing the app when your trying to click on the status icon to un-iconify it
        self.window.connect("window-state-event", self.window_state_event,  status_icon.icon)
    
        # Sets the border width of the window.
        self.window.set_border_width(10)

	self.hbox = gtk.HBox(False, 5)
	self.vbox = gtk.VBox(False, 5)

        #don't need to do this again
        #self.label = gtk.Label("\n"+fullmessage+"\n\n"+fullmessageappend+"\n")	

        self.label.set_line_wrap(True);
        self.label.set_width_chars(80);
        #self.label.modify_font(pango.FontDescription("Bitstream Vera Mono"))
        #self.label.modify_font(pango.FontDescription("Lucida Console"))
        #self.label.modify_font(pango.FontDescription("Courier 12"))
        #self.label.modify_font(pango.FontDescription("Nimbus Mono L"))
        #self.label.modify_font(pango.FontDescription("Courier New"))
        self.label.modify_font(pango.FontDescription("Liberation Mono"))

        if (countup == True):
            self.helplabel = gtk.Label('\nMinimize:\n  shows the time used in the taskbar at the bottom of the screen.\n\nClose:\n  shows an icon in the status area at the bottom-right of the screen.\n  You can mouse-over the status icon to display the time used\n  or click it to restore this dialog.\n')	
        else:
            self.helplabel = gtk.Label('\nMinimize:\n  shows the time remaining in the taskbar at the bottom of the screen.\n\nClose:\n  shows an icon in the status area at the bottom-right of the screen.\n  You can mouse-over the status icon to display the time remaining\n  or click it to restore this dialog.\n')	
        self.helpframe = gtk.Frame("Help")
        self.frame = gtk.Frame("Time Usage Details")
        self.frame.add(self.label)
        self.helpframe.add(self.helplabel)
    
        self.button1 = gtk.Button("Minimize")
        self.button2 = gtk.Button("Close")
    
        self.button1.connect("clicked", self.iconify, None)
        self.button2.connect_object("clicked", self.delete_event, self.window, None, status_icon.icon)

        self.vseparator1 = gtk.VSeparator()
        self.vseparator2 = gtk.VSeparator()
	
        self.vbox.pack_start(self.frame, False, False, 0)
        self.vbox.pack_start(self.vseparator1, False, False, 0)
        self.hbox.pack_start(self.button1, True, True, 5)
        self.hbox.pack_start(self.button2, True, True, 5)
        self.vbox.pack_start(self.hbox, False, False, 0)
        self.vbox.pack_start(self.vseparator2, False, False, 0)
        self.vbox.pack_start(self.helpframe, False, False, 0)
    
        self.window.add(self.vbox)

        # show everything
        self.window.show_all()

        #close, put into task tray on startup
        if (start_iconified == True):
            status_icon.icon.set_blinking(False)
            status_icon.icon.set_visible(True)
            self.window.hide()
            self.window.set_urgency_hint(False)

        if (start_minimized == True):
            #status_icon.icon.set_blinking(False)
            #status_icon.icon.set_visible(False)
            self.window.iconify()
            #self.window.hide()
            #self.window.set_urgency_hint(False)

    def main(self):
        gtk.main()


def run():
    global code
    global oldcode
    global pt_status
    global pacrez_dir
    global user
    global start_iconified
    global start_minimized
    global start_windowed
    global countup
    global force_new_session
    global force_new_session_all_users
    global no_rez_required_user_list
    global firstupdate
    global exec_ack

    global custom_message_green
    global custom_message_yellow
    global custom_message_orange
    global custom_message_red
    global custom_message_error
    global blink_green
    global blink_yellow
    global blink_orange
    global blink_red
    global blink_error
    global deiconify_green
    global deiconify_yellow
    global deiconify_orange
    global deiconify_red
    global deiconify_error

    exec_ack=0
    firstupdate=1
    pacrez_dir='/usr/share/pacrez/'
    code="start"
    oldcode=code

    #get config from config file
    config=ConfigParser.ConfigParser()
    default_cfg = StringIO.StringIO("""\
[pacrez]
countup=0
start_iconified=0
start_minimized=0
start_windowed=0
force_new_session=0
force_new_session_all_users=0
custom_message_green=
custom_message_yellow=
custom_message_orange=
custom_message_red=
custom_message_error=
blink_green=0
blink_yellow=0
blink_orange=1
blink_red=1
blink_error=0
deiconify_green=0
deiconify_yellow=1
deiconify_orange=1
deiconify_red=0
deiconify_error=0
no_rez_required_user_list=[]
    """)
    config.readfp(default_cfg)
    config.read("/etc/groovix/pacrez.conf")
    countup=int(config.get('pacrez','countup'))
    start_iconified=int(config.get('pacrez','start_iconified'))
    start_minimized=int(config.get('pacrez','start_minimized'))
    start_windowed=int(config.get('pacrez','start_windowed'))

    custom_message_green=config.get('pacrez','custom_message_green')
    custom_message_yellow=config.get('pacrez','custom_message_yellow')
    custom_message_orange=config.get('pacrez','custom_message_orange')
    custom_message_red=config.get('pacrez','custom_message_red')
    custom_message_error=config.get('pacrez','custom_message_error')

    blink_green=int(config.get('pacrez','blink_green'))
    blink_yellow=int(config.get('pacrez','blink_yellow'))
    blink_orange=int(config.get('pacrez','blink_orange'))
    blink_red=int(config.get('pacrez','blink_red'))
    blink_error=int(config.get('pacrez','blink_error'))

    deiconify_green=int(config.get('pacrez','deiconify_green'))
    deiconify_yellow=int(config.get('pacrez','deiconify_yellow'))
    deiconify_orange=int(config.get('pacrez','deiconify_orange'))
    deiconify_red=int(config.get('pacrez','deiconify_red'))
    deiconify_error=int(config.get('pacrez','deiconify_error'))

    #legacy
    force_new_session=int(config.get('pacrez','force_new_session'))
    #new
    force_new_session_all_users=int(config.get('pacrez','force_new_session_all_users'))
    no_rez_required_user_list=config.get('pacrez','no_rez_required_user_list')

    #get config from command line
    parser = OptionParser()
    parser.add_option("-u", "--user", dest="user", default=None,  help="user name")
    parser.add_option("-i", "--start_iconified", dest="start_iconified_cl", default=False, action="store_true",  help="whether to start only showing in the systray")
    parser.add_option("-m", "--start_minimized", dest="start_minimized_cl", default=False, action="store_true",  help="whether to start only showing in the systray")
    parser.add_option("-w", "--start_windowed", dest="start_windowed_cl", default=False, action="store_true",  help="whether to start only showing in the systray")
    (options, args) = parser.parse_args()
    user=options.user
    if (options.start_iconified_cl == True):
        #then force on, regardless of whatever may have been in the config file
        start_iconified=True
        start_minimized=False
    if (options.start_minimized_cl == True):
        #then force off, regardless of whatever may have been in the config file
        start_minimized=True
        start_iconified=False
    if (options.start_windowed_cl == True):
        #then force off, regardless of whatever may have been in the config file
        start_iconified=False
        start_minimized=False


    #print "start_iconified is",start_iconified




    pt_status = PacRezStatus()
    pt_status.main()

if __name__ == "__main__":
    run()
